<template>
  <section class="wrapper">
    <div
      class="init"
      v-if="isInit">
      <p>Travelling...</p>
    </div>
    <div v-else-if="isDuel">
      <div v-if="playerRound">
        <b-button
          @click="charAttack">
          attack
        </b-button>
        <b-button
          @click="charSkill">
          skill
        </b-button>
        <b-button
          @click="charItem">
          item
        </b-button>
      </div>
    </div>
  </section>
</template>

<script>
export default {
  data() {
    return {
      battle: {
        states: ['INIT','DUEL','CHK','END'],
        duelist: {
          player: 0,
          foe: 1
        },
        cur_duelist: null,
        foes: [],
        allDrop: [],
        allXP: 0,
        nextLocation: null,
        curr_state: 0,
        cur_foe_hp: null
      },
      char_move: null,
      char: {
        name: 'Fabinho Mocks',
        game_class_id: 1,
        level: 99,
        gold: 8391,
        exp: 71268,
        curr_hp: 1,
        curr_mp: 2,
        curr_ap: 3,
        curr_location_id: 1,
        bag: [
          {name: 'batata', cost: 10},
          {name: 'fabio shield', cost: 10, equipment: {type: 4} },
        ],
        stats: {
          hp: 10,
          mp: 10,
          ap: 10,
          str: 10,
          def: 10,
          int: 10,
          dex: 10,
          agi: 10,
          luk: 10,
        },
        char_current_equipment: {
          torso: {name:'fabio helmet', cost: 10},
          feet: {name:'chinela', cost: 10}
        }
      },
      path: null
    };
  },
  created() {
    this.path = {departure_id: 1, destination_id: 2, length: 1};
    // calcular as batalhas dado o path atual
    let ins = this,
        N = Math.floor(Math.random() * (this.path.length+1));

    this._selectMonsters(N);

    if (this.battle.foes.length > 0) {
      setTimeout(() => {
        ins.battle.curr_state++;
        ins.battle.cur_foe = ins.battle.foes.pop();
        ins._chooseFirst();

        if (!this.playerRound)
          this._goMonster();
      }, 2000);
    } /*else {
      // salta pro final
    }*/
  },
  computed: {
    playerRound() {
      return this.battle.cur_duelist == this.battle.duelist.player;
    },
    isInit() {
      return this.battle.states[this.battle.curr_state] == 'INIT';
    },
    isDuel() {
      return this.battle.states[this.battle.curr_state] == 'DUEL';
    }
  },
  watch: {
    char_move() {
      this._moveChar();
    }
  },
  methods: {
    _selectMonsters(N) {
      // query no back pelos monstros do path
      // seleciona uniformemente entre eles
      this.battle.foes = [
        {
          name: 'monstrengo',
          stats: this.char.stats,
          drops: [
            {
              chance: 0.7,
              item: {
                name: 'das',
                cost: 30
              }
            }
          ],
          skills: [
            {
              name: 'Xenofobia',
              special: {
                target_self: false,
                power: 40,
                stat: 0
              },
              accuracy: 97,
              cost_amout: 30,
              cost_type: 1,
              ref_stat: 2
            }
          ]
        },
        {
          name: 'monstroso',
          stats: this.char.stats,
          drops: [
            {
              chance: 0.9,
              item: {
                name: 'sad',
                cost: 50
              }
            }
          ]
        }
      ];
    },
    _first(foe) {
      return foe.stats.agi > this.char.stats.agi ? this.battle.duelist.foe : this.battle.duelist.player;
    },
    charAttack() {
      this.char_move = 'attack';
    },
    charSkill() {
      this.char_move = 'skill';
    },
    charItem() {
      this.char_move = 'item';
    },
    _chooseFirst() {
      this.battle.cur_duelist = 
          this.battle.cur_foe.stats.agi > this.char.stats.agi ?
              this.battle.duelist.foe : this.battle.duelist.player;
    },
    _goMonster() {
      let moves = ['attack'];
      moves.add(cur_foe.skills);
      moves.shuffle();
      let sel_move = moves.pop();

      if (sel_move == 'attack') {
        
      } else {
        let target = sel_move.special.target_self ? char : cur_duelist;
        let delta = (sel_move.special.target_self ? 1 : -1) * sel_move.special.power / 10 * sel_move.ref_stat;
        let stat = sel_move.special.stat;

        if (Math.random() * 100 > sel_move.accuracy)
          delta = 0;

        let statmap = ['hp', 'mp', 'ap'];

        target.stats[`current_${statmap[stat]}`] += delta;
      }
    },
    _moveChar() {
      // VezJogador
      this.battle.cur_duelist = this.battle.duelist.foe;
      this._goMonster();
    }
  }
}
</script>
